SystemOrganization addCategory: #'2017-TyH'!

Object subclass: #Cipher
	instanceVariableNames: 'key alphabet'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2017-TyH'!

!Cipher commentStamp: '<historical>' prior: 0!
Clase padre de todos los cifradores!

Cipher subclass: #Cesar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2017-TyH'!

!Cesar commentStamp: '<historical>' prior: 0!
Clase que hereda de Cipher.

Implementa el metodo de cifrado y descifrado por el método Cesar!

!Cesar methodsFor: 'public' stamp: 'AF 7/28/2017 15:39'!
decrypt: input
	|result|
	self withKey: (alphabet size) - 3.
	result := self encrypt: input.
	self withKey: 3.
	^result.! !

!Cesar methodsFor: 'public' stamp: 'JuanPablo 8/29/2017 22:15'!
encrypt: input
	| read write abc |
	"Paso el string de entrada a readStream"
	read := input readStream reset.
	"Creo un writeStream para el resultado final"
	write := String new writeStream reset.
	"Paso el alfabeto a un string"
	abc := alphabet readStream.
	
	[ read atEnd ]
	whileFalse:
	[
		| aux aux2 |
		abc reset.
		aux := read next.
		"Si no pertenece al alfabeto definido"
		(abc skipTo: aux)
		ifFalse: [ write nextPut: aux]
		"Si pertenece al alfabeto definido, aplico el corrimiento"
		"Verifico que no sobrepase el limite del alfabeto"
		ifTrue: [
			aux2 := (key - 1 + abc position).
			(aux2 >= (abc size))
			ifTrue: [ abc reset. abc skip: (aux2 - abc size) ]
			ifFalse: [
				abc skip: key - 1.
			].
			aux2:= abc next. write nextPut: aux2.
		].
	].
	^write contents.! !

!Cesar methodsFor: 'initialization' stamp: 'JuanPablo 7/20/2017 21:35'!
initialize
	"comment stating purpose of message"
	super initialize.
	key := 3.! !

!Cipher methodsFor: 'public' stamp: 'JuanPablo 9/2/2017 16:30'!
composeWith: inputCipher
	| multiCipher |
	multiCipher := MultiCipher new.
	multiCipher composeWith: self.
	multiCipher composeWith: inputCipher.
	^multiCipher.! !

!Cipher methodsFor: 'public' stamp: 'JuanPablo 7/25/2017 20:33'!
decrypt: input
	"Este metodo se encarga de retornar la cadena input de forma desencriptada"
	self subclassResponsibility! !

!Cipher methodsFor: 'public' stamp: 'JuanPablo 7/17/2017 21:39'!
encrypt: input
	"Este metodo se encarga de retornar la cadena input de forma encriptada"
	self subclassResponsibility! !

!Cipher methodsFor: 'initialization' stamp: 'JuanPablo 7/19/2017 18:31'!
initialize
	"Inicializa la estructura abecedario (a .. z)"
	key := 0.
	alphabet := 'abcdefghijklmnopqrstuvwxyz'.! !

!Cipher methodsFor: 'public' stamp: 'JuanPablo 7/20/2017 21:42'!
withAlphabet: newAlphabet
	alphabet := newAlphabet.! !

!Cipher methodsFor: 'public' stamp: 'JuanPablo 7/20/2017 21:41'!
withKey: newKey
	"Inicializar el objeto con la clave pasada por parametro"
	key := newKey! !

Cipher subclass: #MultiCipher
	instanceVariableNames: 'ciphersCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2017-TyH'!

!MultiCipher commentStamp: '<historical>' prior: 0!
Clase que hereda de Cipher.

Esta clase permite crear una lista de cifradores para luego utilizarlos en seria para cifrar o descifrar mensajes.!

!MultiCipher methodsFor: 'public' stamp: 'JuanPablo 9/2/2017 16:40'!
composeWith: inputCipher
	ciphersCollection addLast: inputCipher.! !

!MultiCipher methodsFor: 'public' stamp: 'AF 7/28/2017 00:27'!
decrypt: input
	| output |
	
	"Si el conjunto de ciphers esta vacio retorno la misma caden de entrada"
	(ciphersCollection isEmpty)
	ifTrue: [ ^input ].
	
	output := input.
	"Si el conjunto de ciphers posee elementos, encripto la cadena de entrada utilizando el metodo encrypt de cada cipher"
	ciphersCollection reverseDo: [ :each | output := each decrypt: output. ].
	^output.! !

!MultiCipher methodsFor: 'public' stamp: 'AF 7/28/2017 14:30'!
encrypt: input
	"Input"
	| output |
	
	"Si el conjunto de ciphers esta vacio retorno la misma caden de entrada"
	(ciphersCollection isEmpty)
	ifTrue: [ ^input ].
	
	output := input.
	"Si el conjunto de ciphers posee elementos, encripto la cadena de entrada utilizando el metodo encrypt de cada cipher"
	ciphersCollection do: [ :each | output := each encrypt: output. ].
	^output.! !

!MultiCipher methodsFor: 'initialization' stamp: 'AF 7/28/2017 14:30'!
initialize
	"Inicializar"
	super initialize.
	ciphersCollection := OrderedCollection new.! !

Cipher subclass: #RailFence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2017-TyH'!

!RailFence commentStamp: '<historical>' prior: 0!
Clase que hereda de Cipher.

Esta clase implementa el método Rail Fece para cifrar y descifrar mensajes.!

!RailFence methodsFor: 'public' stamp: 'Anonymous 9/5/2017 08:53'!
decrypt: input
	"Este metodo retorna la cadena input desencriptada"
	| read write arrayWStream arrayRStream arrayConts cola1 cola2 |
	"Si la key es cero retorno la misma cadena"
	(key=0)
	ifTrue: [ ^input. ].
	"Paso el string de entrada a readStream"
	read := input readStream.
	read reset.
	
	"Inicializo las colas para saber que stream_index corresponde"
	cola1 := self initQueue: key.
	cola2 := self initQueue: key.

	"Inicializo los contadores para saber cuantos caracteres van en cada Stream del arrayStream"	
	"Para el ejemplo de 'holamundo' y key:3, cont1=3, cont2=4 y cont3=2"
	arrayConts := self initArrayConts: input cola: cola1.

	"Inicializo el arrayStream de acuerdo a la Key establecida. Es decir, cada Stream va a tener su respectiva cadena"
	"Para el ejemplo de 'holamundo' y key:3, el stream1=[hmo], el stream2=[oaud] y el stream3=[ln]"
	arrayWStream := self initWStream:key read:read  arrayConts: arrayConts.
	"Paso los writeStreams a readStreams"
	arrayRStream := self initRStream: key WStream: arrayWStream.
	
	"Voy tomando un caracter por stream del arrayRStream, y armando la salida con el mensaje desencriptado"
	write := String new writeStream.
	(Interval from: 1 to: (input size)) do:
	[
		:index |
		| n |
		n := cola2 next.
		write nextPut: ((arrayRStream at: n) next).
		cola2 nextPut: n.
	].
	
	 ^write contents.! !

!RailFence methodsFor: 'public' stamp: 'Anonymous 9/5/2017 08:41'!
encrypt: input
	| read write arrayStream cola |
	"Si la key es cero retorno la misma cadena"
	(key=0) ifTrue: [ ^input. ].
	"Paso el string de entrada a readStream"
	read := (input copyWithRegex: '\s' matchesReplacedWith: '') readStream.
	
	"Inicializo el arrayStream de acuerdo a la Key establecida"
	arrayStream := Array new: key.
	(Interval from: 1 to: key) do: [ :index | arrayStream at: index put: String new writeStream ].
	
	"Inicializo la cola para saber que stream_index corresponde"
	cola := self initQueue: key.

	"Encripto el msj repartiendo la cadena de entrada entre los distintos Streams del array"
	[ read atEnd ]
	whileFalse:
	[
		| index aux |
		aux := String with: read next.
		index := cola next.
		(arrayStream at: index) nextPutAll: aux.
		cola nextPut: index.
	].
	write := String new writeStream.
	1 to: key do: [ :index | write nextPutAll: ((arrayStream at:index) contents) ].
	^write contents.! !

!RailFence methodsFor: 'private' stamp: 'Anonymous 9/5/2017 08:46'!
initArrayConts: input cola:cola1
	|arrayConts|
	arrayConts := Array new: (input size).
	(Interval from: 1 to: (input size)) do: [ :index | arrayConts at: index put: 0 ].
	(Interval from: 1 to: (input size)) do:
	[	
		:index |
		| indice temp2 |
		indice := cola1 next.
		temp2 := arrayConts at: indice.
		temp2 := temp2 + 1.
		arrayConts at: indice put: temp2.
		cola1 nextPut: indice.
	].
	^arrayConts.! !

!RailFence methodsFor: 'private' stamp: 'Anonymous 9/5/2017 08:41'!
initQueue: keyParam
	|cola|
	cola := SharedQueue new.
	1 to: keyParam do: [ :index | cola nextPut: index ].
	(2 <= (keyParam-1))
	ifTrue: [ (keyParam-1) to: 2 by: (-1) do:[ :each| cola nextPut: each ]. ].
	^cola.! !

!RailFence methodsFor: 'private' stamp: 'Anonymous 9/5/2017 08:52'!
initRStream: keyParam WStream:arrayWStream
	|arrayRStream aux|
	arrayRStream := Array new: keyParam.
	(Interval from: 1 to: keyParam) do: 
	[
		:index |
		aux := (arrayWStream at: index) contents.
		aux := aux readStream.
		arrayRStream at: index put: aux.
		(arrayRStream at: index) reset.
	].
	^arrayRStream.! !

!RailFence methodsFor: 'private' stamp: 'Anonymous 9/5/2017 08:49'!
initWStream: keyParam read:read arrayConts:arrayConts
	|arrayWStream|
	arrayWStream := Array new: keyParam.
	(Interval from: 1 to: keyParam) do: [ :index | arrayWStream at: index put: String new writeStream. ].
	(Interval from: 1 to: keyParam) do:
	[
		:index |
		| temp2 |
		temp2 := arrayConts at: index.
		1 to: temp2 do: [ :index2 | (arrayWStream at: index) nextPut: (read next) ].
	].
	^arrayWStream.! !

!RailFence methodsFor: 'initialization' stamp: 'JuanPablo 7/19/2017 18:38'!
initialize
	"comment stating purpose of message"
	super initialize.
	key := 1.! !

!RailFence methodsFor: 'public' stamp: 'AF 7/27/2017 21:15'!
withKey: newKey
	"Inicializar el objeto con la clave pasada por parametro"
	|temp|
	temp := newKey.
	[temp := temp +1. key := newKey] on: Error do: [:e | 'Oops!! ' , e className , '!!'].
	! !

Cipher subclass: #TransposicionCC
	instanceVariableNames: 'regular replaceChar'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2017-TyH'!

!TransposicionCC commentStamp: '<historical>' prior: 0!
Clase que hereda de Cipher.

Esta clase implementa el método Trasposicion por columna canónica para cifrar y descifrar mensajes.!

!TransposicionCC methodsFor: 'public' stamp: 'JuanPablo 8/29/2017 23:37'!
decrypt: input
	"Este metodo retorna la cadena input desencriptada"
	| read write arrayWStream arrayRStream cola1 arrayConts ordered |
	"Paso el string de entrada a readStream"
	read := input readStream.
	read reset.
	
	"Inicializo la colas para el orden de las columnas (Cola circular)"
	cola1 := SharedQueue new.
	1 to: (key size) do: [ :index | cola1 nextPut: index ].

	"Calculo cuantos caracteres tendra cada Stream, es decir, cada columna"
	arrayConts := Array new: (key size).
	(Interval from: 1 to: (key size)) do: [ :index | arrayConts at: index put: 0 ].
	(Interval from: 1 to: (input size)) do:
	[	
		:index |
		| indice temp2 |
		indice := cola1 next.
		temp2 := arrayConts at: indice.
		temp2 := temp2 + 1.
		arrayConts at: indice put: temp2.
		cola1 nextPut: indice.
	].
	
	"Ordeno la key para saber cuantos caracteres de input corresponden a cada caracter de la Key"
	ordered := key asSortedCollection: [:a :b | a < b ].
	
	"Inicializo el arrayStream de acuerdo a la Key establecida. Es decir, cada Stream va a tener su respectiva cadena"
	"Para el ejemplo de 'holamundo' y key:zebras, s1:[ M ], s2:[ LO ], s3:[ OD ], s4:[ A ], s5:[ U ], s6:[ HN ]"
	arrayWStream := Array new: (key size).
	
	(Interval from: 1 to: (key size)) do: [ :index | arrayWStream at: index put: String new writeStream. ].
	(Interval from: 1 to: (key size)) do:
	[
		:index |
		| pos tempReadStream |
		tempReadStream := key readStream.
		tempReadStream reset.
		tempReadStream skipTo: (ordered at: index).
		pos := tempReadStream position.
		1 to: (arrayConts at: pos) do: [ :index2 | (arrayWStream at: pos) nextPut: (read next) ].
	].
	
	"Paso los writeStreams a readStreams"
	arrayRStream := Array new: (key size).
	(Interval from: 1 to: (key size)) do: 
	[
		:index |
		| aux |
		aux := (arrayWStream at: index) contents.
		aux := aux readStream.
		arrayRStream at: index put: aux.
		(arrayRStream at: index) reset.
	].
	
	"Voy tomando un caracter por stream del arrayRStream, y armando la salida con el mensaje desencriptado"
	cola1 := SharedQueue new.
	1 to: (key size) do: [ :index | cola1 nextPut: index ].
	
	write := String new writeStream.
	(Interval from: 1 to: (input size)) do:
	[
		:index |
		| n charAux|
		n := cola1 next.
		charAux := ((arrayRStream at: n) next).
		(charAux = replaceChar)
		ifFalse: [write nextPut: charAux].
		cola1 nextPut: n.
	].
	(regular )
	ifTrue: [^(write contents) copyWithRegex: ('\', replaceChar)  matchesReplacedWith: ''.]
	ifFalse: [^write contents.]! !

!TransposicionCC methodsFor: 'public' stamp: 'FontanAlejandro 9/5/2017 09:35'!
encrypt: input
	"Comment.."
	| read arrayStream cola max |
	"Paso el string de entrada a readStream"
	read := (input copyWithRegex: '\s' matchesReplacedWith: '') readStream reset.
	"read reset."

	max := 0.

	"Inicializo el arrayStream de acuerdo a la cantidad de columnas definida por la key"
	arrayStream := self initArrayStream: key.
	
	"Inicializo la cola para saber que stream_index corresponde (COLA CIRCULAR)"
	cola := self initQueue: key.
	
	"Reparto la cadena de entrada entre los distintos Streams del array"
	self shareIn: read cola: cola  arrayStream: arrayStream.
	
	"Creo una sort Collection para ver en que orden iran los streams (columnas)"
	regular
		ifTrue: [ max := (input size rem: key size) = 0
				ifFalse: [ input size // key size + 1 ]
				ifTrue: [ input size // key size ] ].
			
	"write := ''."
	
	^(self processAux: key max: max  arrayStream:arrayStream) contents.! !

!TransposicionCC methodsFor: 'private' stamp: 'FontanAlejandro 9/5/2017 09:00'!
initArrayStream: keyParam
	|arrayStream|
	arrayStream := Array new: (keyParam size).
	(Interval from: 1 to: (keyParam size)) do: [ :index | arrayStream at: index put: String new writeStream ].
	^arrayStream.! !

!TransposicionCC methodsFor: 'private' stamp: 'FontanAlejandro 9/5/2017 09:08'!
initOrdered: keyParam
	|ordered|
	ordered := Array new: (keyParam size).
	(Interval from: 1 to: (keyParam size)) do: [ :index | ordered at:index put: (keyParam at:index)].
	ordered := ordered asSortedCollection: [:a :b | a < b ].
	^ordered.! !

!TransposicionCC methodsFor: 'private' stamp: 'FontanAlejandro 9/5/2017 08:57'!
initQueue: keyParam
	|cola|
	cola := SharedQueue new.
	(Interval from: 1 to: (keyParam size)) do: [ :index | cola nextPut: index ].
	^cola.! !

!TransposicionCC methodsFor: 'initialization' stamp: 'JuanPablo 7/28/2017 10:15'!
initialize
	super initialize.
	key := 'a'.
	regular := false.
	self replaceWith: '*'.! !

!TransposicionCC methodsFor: 'public' stamp: 'JuanPablo 7/28/2017 09:21'!
notRegularMode
	regular := false.! !

!TransposicionCC methodsFor: 'private' stamp: 'FontanAlejandro 9/5/2017 09:33'!
processAux: keyParam max: max arrayStream: arrayStream
	|write posRepeat ordered aux readParam|
 	write := String new writeStream.
	readParam := key readStream.
	ordered := self initOrdered: keyParam.
	
	posRepeat := 1.
	(Interval from: 1 to: (keyParam size)) do:
	[ :index |
		readParam reset.
		(posRepeat=1)
		"Si el elemento no estaba repetido dentro de la key:"
		ifTrue:
		[
			"Busco la posicion del siguiente valor de la key"
			readParam skipTo: (ordered at:index).
			aux := readParam position.
		]
		"Si estaba repetido tomo la posicion de dicho valor"
		ifFalse: [ aux := posRepeat. readParam skip: posRepeat. ].
		
		"Verifico si el elemento posee repetidos dentro de la key"
		"Avanzo hasta la posicion siguiente al ultimo repetido encontrado"
		"Si encotro algun repetido:"
		posRepeat := (readParam skipTo: (ordered at: index))
			ifTrue: [ readParam position ]
			ifFalse: [ 1 ].
		
		write nextPutAll: ((arrayStream at: aux) contents).
		(regular)
		ifTrue:
		[
			(((arrayStream at: aux) size) < max)
			ifTrue: [ write nextPutAll: replaceChar contents ].
		].
	].
	^write.! !

!TransposicionCC methodsFor: 'public' stamp: 'JuanPablo 7/20/2017 23:13'!
regularMode
	regular := true.! !

!TransposicionCC methodsFor: 'public' stamp: 'Anonymous 7/27/2017 18:40'!
replaceWith: element
	
		replaceChar := element.! !

!TransposicionCC methodsFor: 'private' stamp: 'FontanAlejandro 9/5/2017 09:18'!
shareIn: readParam cola:cola arrayStream: arrayStream
	|aux cont |
	[ readParam atEnd ]
	whileFalse:
	[
		aux := String with: readParam next.
		cont := cola next.
		(arrayStream at: cont) nextPutAll: aux.
		cola nextPut: cont.
	].
	! !

Cipher subclass: #Vigenere
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2017-TyH'!

!Vigenere commentStamp: '<historical>' prior: 0!
Clase que hereda de Cipher.

Esta clase implementa el método Vignere para cifrar y descifrar mensajes.!

!Vigenere methodsFor: 'public' stamp: 'JuanPablo 8/29/2017 23:01'!
decrypt: input
	| read write "abc" aux temp cesars cont |
	"Paso el string de entrada a readStream"
	read := (input copyWithRegex: '\s' matchesReplacedWith: '') readStream reset.
	"Creo un writeStream para el resultado final"
	write := String new writeStream reset.
	cesars := self getArrayCesarsFoward: false.
	
	"Encripto el input mediante el array cesars y lo guardo en write"
	cont := 1.
	[ read atEnd ]
	whileFalse:
	[
		"Si llegue al final del array vuelvo a iniciar,"
		(cont > (cesars size))
		ifTrue: [ cont := 1].
		"Tomo el siguiente caracter de la cadena a encriptar"
		temp := String with: read next.
		"Encripto el caracter segun el cesar que le corresponda del array"
		aux := (cesars at: cont) encrypt: temp.
		"Almaceno el caracter encriptado en el stream de salida"
		write nextPutAll: aux.
		cont := cont + 1.
	].
	^write contents.! !

!Vigenere methodsFor: 'public' stamp: 'JuanPablo 8/29/2017 23:00'!
encrypt: input
	| read write aux temp cesars cont |
	"Paso el string de entrada a readStream"
	read := (input copyWithRegex: '\s' matchesReplacedWith: '') readStream.
	read reset.
	"Creo un writeStream para el resultado final"
	write := String new writeStream.
	write reset.

	cesars := self getArrayCesarsFoward: true.
	"Encripto el input mediante el array cesars y lo guardo en write"
	cont := 1.
	[ read atEnd ]
	whileFalse:
	[
		"Si llegue al final del array vuelvo a iniciar,"
		(cont > (cesars size))
		ifTrue: [ cont := 1].
		"Tomo el siguiente caracter de la cadena a encriptar"
		temp := String with: read next.
		"Encripto el caracter segun el cesar que le corresponda del array"
		aux := (cesars at: cont) encrypt: temp.
		"Almaceno el caracter encriptado en el stream de salida"
		write nextPutAll: aux.
		cont := cont + 1.
	].
	^write contents.! !

!Vigenere methodsFor: 'private ' stamp: 'JuanPablo 8/29/2017 23:03'!
getArrayCesarsFoward: foward
	| abc cesars temp aux |
	"Paso el alfabeto a un string"
	abc := alphabet readStream.
	
	"Creo un arreglo de cifradores cesar, e inicializo cada uno con una key de acuerdo a cada caracter de la key del Vigenere"
	cesars := Array new: (key size).
	(Interval from: 1 to: (key size)) do: [ :index | 
			abc reset.
			abc skipTo: (key at: index).
			temp := foward
				ifTrue: [ abc position - 1 ]
				ifFalse: [ abc size - abc position + 1 ].
			aux := Cesar new. aux withKey: temp. cesars at: index put: aux
		].
	"Retorno el arreglo"
	^cesars.! !

!Vigenere methodsFor: 'initialization' stamp: 'JuanPablo 7/19/2017 18:34'!
initialize
	"comment stating purpose of message"
	super initialize.
	key := 'a'.! !
